import {
  FormatterParserProvider, Config, Mask, IDictionary,
} from '@zeedhi/core';
import { PmeMask } from '@/config';

FormatterParserProvider.registerFormatter('CnpjMask', (value: string, {
  cnpjMask = (Config.masks.cnpjMask as PmeMask).pattern,
}: IDictionary = {}) => (value && cnpjMask ? Mask.getValueWithMask(value, cnpjMask) : value));

FormatterParserProvider.registerParser('CnpjMask', (value: string, {
  cnpjMask = (Config.masks.cnpjMask as PmeMask).pattern,
}: IDictionary = {}) => (value && cnpjMask ? Mask.getValueWithoutMask(value) : value));

FormatterParserProvider.registerFormatter('CpfMask', (value: string, {
  cpfMask = (Config.masks.cpfMask as PmeMask).pattern,
}: IDictionary = {}) => (value && cpfMask ? Mask.getValueWithMask(value, cpfMask) : value));

FormatterParserProvider.registerParser('CpfMask', (value: string, {
  cpfMask = (Config.masks.cpfMask as PmeMask).pattern,
}: IDictionary = {}) => (value && cpfMask ? Mask.getValueWithoutMask(value) : value));

FormatterParserProvider.registerFormatter('ProductMask', (value: string, {
  productMask = (Config.masks.productMask as PmeMask).pattern,
}: IDictionary = {}) => (value && productMask ? Mask.getValueWithMask(value, productMask) : value));

FormatterParserProvider.registerParser('ProductMask', (value: string, {
  productMask = (Config.masks.productMask as PmeMask).pattern,
}: IDictionary = {}) => (value && productMask ? Mask.getValueWithoutMask(value) : value));

FormatterParserProvider.registerFormatter('PlateMask', (value: string, {
  plateMask = (Config.masks.plateMask as PmeMask).pattern,
}: IDictionary = {}) => (value && plateMask ? Mask.getValueWithMask(value, plateMask) : value));

FormatterParserProvider.registerParser('PlateMask', (value: string, {
  plateMask = (Config.masks.plateMask as PmeMask).pattern,
}: IDictionary = {}) => (value && plateMask ? Mask.getValueWithoutMask(value) : value));
